//
//Script: SiteKiosk Logfile upload via ftp / Copyright PROVISIO GmbH 2007
//!!Note that you need to adjust at least the ftp commands variables to make this work with your ftp server!!
//!!This script uses the ftp.exe that ships with XP!! Note that the script only checks if ftp.exe executed without an error, this is no guarantee the files have actually been uploaded.
//The script is not suited for dial-up connections as it does not check if a valid connection exists. 
//Feel free to change the script to make it fit your needs.
//
//XML support
var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");

//Wsh Shell Object
var WshShell = new ActiveXObject("WScript.Shell");

//File Scripting Object
var fso = new ActiveXObject("Scripting.FileSystemObject");

//path of the SiteKiosk logfile folder
var folderspec = SiteKiosk.SiteKioskDirectory + "\Logfiles";

//path to logfileupload.xml
var logfileuploadxmlpath = SiteKiosk.SiteKioskDirectory + "\Logfiles\\logftp\\logfileupload.xml";

//path for the ftp commands file
var commandstxt = SiteKiosk.SiteKioskDirectory + "\Logfiles\\logftp\\ftp_commands.txt";

//basic ftp commands
var gstr_ftpaddress = "www.myftpserver.com"; //domain or ip
var gstr_user = "ftpusername"; //user name for the ftp connection
var gstr_password = "ftpuserpassword"; //password for the ftp connection

//Logfile to send
var logfile = getFileToSend();
SiteKiosk.Logfile.Notification("Logfile to upload is: " + logfile);

if(logfile != "")
{
	sendLogFtp(logfile);
}
else
	SiteKiosk.Logfile.Notification("No logfiles found. There will be no upload!");

//functions
function getFileToSend()
{
	//variables needed for this function
    var folder, fileenum, lastfiletosend;
    var returnstrg = "";
    var counter = 0;
   
    folder = fso.GetFolder(folderspec);
    fileenum = new Enumerator(folder.files);
    for (; !fileenum.atEnd(); fileenum.moveNext())
    {
   		counter++;
   		lastfiletosend = folder.files.count.valueOf() - 1;
   		if(counter == lastfiletosend)
   			returnstrg = fileenum.item();
    }
    return returnstrg;
}

function sendLogFtp(logtosend)
{
	f = fso.CreateTextFile(commandstxt, true);
	f.WriteLine("Open " + gstr_ftpaddress);
	f.WriteLine(gstr_user);
	f.WriteLine(gstr_password);
	//if you need to change folders on the ftp server (repeat if needed):
	//f.WriteLine("cd foldername");
	f.WriteLine("send \"" + logtosend + "\"");
	f.WriteLine("quit");
	f.Close();

	var li_errorcode = 0;
	
	try
	{
		//make sure the path of the file to execute is absolutely correct, especially when running SiteKiosk in shell replacement, otherwise this will cause unwanted effects
		li_errorcode = WshShell.Run("ftp.exe -s:\"" + commandstxt + "\"",0,true);
	}
	catch(e)
	{
		li_errorcode = -1;
	}
	
	f = fso.GetFile(commandstxt);
	f.Delete();
	
	if(li_errorcode != 0)
		OnFtpError(true,li_errorcode);
	else
		OnFtpError(false,li_errorcode);
}

function OnFtpError(result,li_errorcode)
{
	if(result)
	{
		SiteKiosk.Logfile.Notification("FTP file transfer not executed properly. Error code: " + li_errorcode);
		
		//handle the failed upload
		if(xmlDoc.load(logfileuploadxmlpath))
		{
			//check if the failed upload failed before
			logexists = false;
			
			nodeselection = xmlDoc.documentElement.selectNodes("//logstosend/logfile");
			if(nodeselection.length > 0)
			{
				for(var i=0;i<nodeselection.length;i++)
				{
					if (logfile == nodeselection.item(i).text)
						logexists = true;
				}
			}
			
			if(!logexists && nodeselection.length < 61)
			{
				currNode = xmlDoc.selectSingleNode("//logstosend");
				newNode = xmlDoc.createNode(1, "logfile", "");
	   			newchildnode = currNode.appendChild(newNode);
	   			newchildnode.text = logfile;
	   			xmlDoc.save(logfileuploadxmlpath);
			}
			else if(!logexists && nodeselection.length > 60)
				SiteKiosk.Logfile.Notification("There are more than 60 logfiles waiting to be uploaded. No more files will be added!");
			else
				SiteKiosk.Logfile.Notification("Logfile is already in the waiting list!");
		}
		else
			SiteKiosk.Logfile.Notification("Error trying to open logfileupload.xml!");
	}
	else
	{
		SiteKiosk.Logfile.Notification("FTP.exe has been executed."); //note that this is no guarantee the file has been actually transfered to the server, fpt.exe has just been executed without returning an error
		
		//remove the successfully uploaded file from the logfileupload.xml if it exists
		if(xmlDoc.load(logfileuploadxmlpath))
		{
			nodeselection = xmlDoc.documentElement.selectNodes("//logstosend/logfile");
			if(nodeselection.length > 0)
			{
				logtodelete = null;
				for(var i=0;i<nodeselection.length;i++)
				{
					if (logfile == nodeselection.item(i).text)
						logtodelete = i;
				}
				
				if(logtodelete != null)
				{
					currNode = xmlDoc.selectSingleNode("//logstosend");
					currNode.removeChild(currNode.childNodes.item(logtodelete));
					xmlDoc.save(logfileuploadxmlpath);
				}
			}
		}
		else
			SiteKiosk.Logfile.Notification("Error trying to open logfileupload.xml!");
		
		//check if previous logs could not be send and send them now
		sendOldLogs();
	}
}

function sendOldLogs()
{
	if(xmlDoc.load(logfileuploadxmlpath))
	{
		//check if there are older files and send the first one of them
		nodeselection = xmlDoc.documentElement.selectNodes("//logstosend/logfile");
		if(nodeselection.length > 0)
		{
			for(var i=0;i<1;i++)
			{
				logfile = nodeselection.item(i).text;
				sendLogFtp(nodeselection.item(i).text);
			}
		}
	}
	else
		SiteKiosk.Logfile.Notification("Error trying to open logfileupload.xml!");	
}